﻿Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.IO
Imports System.Collections
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization

''' <summary>
''' Serializa e Deserializa uma lista de dados de carros
''' para persistir , alterar e exibir os dados em um arquivo 
''' de dados
''' </summary>
Public Class Serializador

    ''' <summary>
    ''' Usa o formato binarioa para salvar os dados dos carros
    ''' para um arquivo
    ''' </summary>
    ''' <param name="strPath"></param>
    ''' <param name="marquivo"></param>
    ''' <remarks></remarks>
    Public Shared Sub Serialize(ByVal strPath As String, ByVal mArquivo As List(Of Carros))

        Dim fs As FileStream = New FileStream(strPath, FileMode.OpenOrCreate)
        Dim formatador As BinaryFormatter = New BinaryFormatter()

        Try
            formatador.Serialize(fs, mArquivo)
            fs.Close()
        Catch ex As SerializationException
            MessageBox.Show(ex.Message + ": " + ex.StackTrace, "Erro", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    ''' <summary>
    ''' Deserializa um arquivo existente retornando uma lista do tipo 
    ''' Carros
    ''' </summary>
    ''' <param name="strPath"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function Deserialize(ByVal strPath As String) As List(Of Carros)

        Dim fs As FileStream = New FileStream(strPath, FileMode.Open)
        Dim mArqwuivo As New List(Of Carros)()

        Try
            Dim Formatter As New BinaryFormatter()
            mArqwuivo = Formatter.Deserialize(fs)
            fs.Close()
            Return mArqwuivo
        Catch ex As SerializationException
            MessageBox.Show(ex.StackTrace, ex.Message, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return mArqwuivo
        End Try

    End Function
End Class
