﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

''' <summary>
''' Este formulario exibe uma lista de nomes de carros
''' uma vez selecionado um evento sera disparado com o nome
''' do carro selecionado e passado como um argumento.
''' O formulario principal irá 'escutar' para processar este evento
''' para atualizar a exibição do carro atual de forma que ele coincida com o 
''' nome procurado.
''' </summary>
Public Class frmProcura

    ' inclui um delegate
    Public Delegate Sub CarroNomeUpdateHandler(ByVal sender As Object, ByVal e As CarroNomeUpdateEventArgs)

    ' e associa um evento para modificar os escutadores
    ' quando o nome do carro é selecionado da lista dos 
    ' nomes de carros
    Public Event CarroNomeUpdated As CarroNomeUpdateHandler

    ''' <summary>
    ''' Passa a lista de dados do carro atual para 
    ''' o construtor de forma que o formulario pode
    ''' gerar uma lista de nomes de carros para o usuario escolher
    ''' no formulario
    ''' </summary>
    ''' <param name="bd"></param>
    ''' <remarks></remarks>
    Public Sub New(ByVal bd As List(Of Carros))

        InitializeComponent()

        ' percorre os dados dos carros para incluir
        ' cada nome de carro a lista de nomes do controle listbox
        For Each carro As Carros In bd
            ListBox1.Items.Add(carro.NomeCarro)
        Next

    End Sub
    ''' <summary>
    ''' Quando o usuário clicar no botão procurar
    ''' dispara um evento de forma que o formulario ira exibir 
    ''' o carro apropriado
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnProcurar_Click(ByVal sender As System.Object, _
                              ByVal e As System.EventArgs) _
                              Handles btnProcurar.Click

        ' preenche a lista de argumentos com o nome do carro
        Dim args As New CarroNomeUpdateEventArgs(ListBox1.SelectedItem.ToString())

        ' dispara o evento para passar o nome do carro de volta 
        ' ao formulario principal para processamento
        RaiseEvent CarroNomeUpdated(Me, args)

    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()
    End Sub
End Class
''' <summary>
''' Container para os argumento de atualizado do nome do carro
''' so ha um argumento neste caso.
''' O nome do carro selecionado da lista de carros
''' </summary>
Public Class CarroNomeUpdateEventArgs
    Inherits System.EventArgs

    Private mCarroNome As String

    ' constructor
    Public Sub New(ByVal sCarroNome As String)

        Me.mCarroNome = sCarroNome

    End Sub
    ' Properties - Acessivel pelo listener
    Public Property CarroNome() As String
        Get
            Return mCarroNome
        End Get
        Set(ByVal value As String)
            mCarroNome = value
        End Set
    End Property


End Class